package pep;

import java.io.*; import java.util.*;
import static pep.Main.nDistracters;
import static pep.Main.nSubjects;

/**This class concatenates individual participant data files into one large
 * dataset called Dataset.txt. It also encodes previous response times,
 * accuracy, and congruency. This class has a main method and can be run
 * independently of the full model*/

public class Concat {
 //----------VARIABLES--------------------------------------------------
 /**file name*/              static String fileName;
 /**number of variables*/    static int nVariables = Main.numPerVar.length;
 /**number of distracter sets*/ static int nSets = nDistracters.length;
 //---------------------------------------------------------------------
 /**response time*/          static int rt;
 /**previous response time*/ static int n1rt;
 /**accuracy*/               static int accuracy;
 /**previous accuracy*/      static int n1acc;
 /**distracter number*/      static int dist = 999;
 /**target number*/          static int targ = 999;
 /**threshold at response*/  static double thresh;

 /**Get data from each participant.*/
 public static void main(String[] args){
  //loop through participants
  for(int i=1; i<=nSubjects; i++){
   //set previous RT and accuracy to null values
   n1rt = 99999; n1acc = 999;
   //record participant data
   getData(i);
  }
 }

 /**Gets the data for the participant and writes it to file.
  * @param i Participant number.*/
 public static void getData(int i){
  //clear I/O streams
  BufferedReader in = null;
  FileOutputStream out = null;
  PrintStream p = null;
  StringTokenizer tokenizer = null;

  //open input and output streams
  try{
   fileName = "out"+i+".txt";
   in = new BufferedReader(new FileReader(fileName));
   if(i>1) out = new FileOutputStream("Dataset.txt", true);
   else out = new FileOutputStream("Dataset.txt");
   p = new PrintStream(out);
  }
  catch(Exception e){
   System.out.println("Error setting input and output streams.");
  }

  //read first trial
  try{
   tokenizer = new StringTokenizer(in.readLine());
  }
  catch(Exception e){
   System.out.println("No data in file.");
  }

  //clear previous and current congruency
  String cong = ""; String n1cong = "";
  //code need for no-distracter tasks
  if(nDistracters[0]==0) nSets=0;

  //loop through data columns
  while(in!=null){
   try{
    //subject
    p.print(tokenizer.nextToken()+"\t");
    //response
    p.print(tokenizer.nextToken()+"\t");
    //target
    targ = Integer.parseInt(tokenizer.nextToken());
    p.print(targ+"\t");
    //distracters
    for(int j=0; j<nSets; j++){
     dist = Integer.parseInt(tokenizer.nextToken());
     p.print(dist+"\t");
    }
    //study variables
    for(int n=0; n<nVariables; n++){
     if(n>0)
      p.print(tokenizer.nextToken()+"\t");
     else{
      //first variable is congruency
      cong = tokenizer.nextToken();
      p.print(""+cong+"\t");
     }
    }
    //correct response
    p.print(tokenizer.nextToken()+"\t");
    //response time
    rt = Integer.parseInt(tokenizer.nextToken());
    //accuracy
    accuracy = Integer.parseInt(tokenizer.nextToken());
    p.print(rt+"\t"+accuracy+"\t");

    //print previous RT and accuracy
    //first trial has no previous trial information
    if(n1rt==99999) p.print(" \t \t"+n1cong);
    //print other trials
    else p.print(n1rt+"\t"+n1acc+"\t"+n1cong);

    //--code for recording threshold at response--
    /*/ <- inset asterisk to lesion
    thresh = Double.parseDouble(tokenizer.nextToken());
    p.println("\t"+thresh);//*/p.println();

    //set previous rt and accuracy for next trial
    n1rt = rt; n1acc = accuracy; n1cong = cong;

    //read next trial
    String tempString = in.readLine();
    //check for END_OF_FILE then send to tokenizer
    if(tempString.equals("END_OF_FILE")) in = null;
    else tokenizer = new StringTokenizer(tempString);
   }
   catch(NumberFormatException | IOException e3){
    in = null;
    System.out.println("No END_OF_FILE in data file.");
   }
  }

  //close input and output streams
  try{
   p.close(); out.close();
  }
  catch(Exception e2){
   System.out.println("Error closing input and output streams");
  }
 }
}