package pep;

import java.util.Random;

/**This Node subclass defines the operations of Response nodes.*/
public class Response extends Node{
 /**amount of activation retrieved*/ public double retrieved;
 /**total amount memory retrieved*/
 public static double[] totRetrieved = new double[Main.nSubjects];
 /**random number generator*/ private Random r = new Random();

 /**Creates a new Response node.
  * @param subject Subject number used for static variable array.*/
 public Response(int subject){
  super(subject);
  threshold = .5;
  retrieved = 0;
 }

 /**Updates response activation.*/
 public void activate(){
  retrieve();
  //add noise
  input += range((r.nextGaussian()*.2)+.5)*.01;
  update();
 }

 /**Adds retrieved activation to input.*/
 private void retrieve(){
  if(totRetrieved[subj]>0){
   //input proportional if total retrieved exceeds 1
   if(totRetrieved[subj]>1) retrieved /= totRetrieved[subj];
   //small threshold
   retrieved -= .1;
   //range result between 0 and .1
   retrieved = range(retrieved,.15);
   //add retrieval input
   input += retrieved;
   retrieved = 0;
  }
 }

 /**Clears totRetrieved for the next cycle.
  * @param subject Subject number used for static variable array.*/
 public static void clear(int subject){
  totRetrieved[subject] = 0;
 }
}